#!/bin/bash
source SVN2GitLab.cfg
echo @@@SVN_HOST:$SVN_HOST@@@

time=`date +%Y_%m_%d_%H_%M_%S`
touch svn2gitlab_$time.log
workdir=`pwd`
echo Group,Repository,Result >> $workdir/svn2gitlab_$time.log
while read line
do
	OLD_IFS="$IFS"
	IFS=","
	line_arr=($line)
	IFS="$OLD_IFS"
	echo @@@${line_arr[@]}@@@
	#create group and get group id
	echo @@@create group ${line_arr[2]}@@@
	return_newgroup=`curl -d "name= ${line_arr[2]}&path=${line_arr[2]}&private_token=$PRIVATE_TOKEN" "http://$GITLAB_HOST/api/v3/groups"`
	if [[ $return_newgroup == *"Failed to save group"* ]]; then
		group_detail=`curl -H "PRIVATE-TOKEN:$PRIVATE_TOKEN" "http://$GITLAB_HOST/api/v3/groups/${line_arr[2]}"`
		json_groupdetail=${group_detail//\"/}
       		echo @@@groupdetail:$json_groupdetail@@@
		tmp_id=${json_groupdetail#*id:}
		group_id=${tmp_id%%,*}
        	echo @@@groupid:$group_id@@@
	else
		json_newgroup=${return_newgroup//\"/}
		echo @@@newgroup:$json_newgroup@@@
		#group_id=$(parse_json $json_newgroup "id")
		group_id=`echo $json_newgroup | sed 's/{.*'id':\([^,]*\).*}/\1/'`
		echo @@@groupid:$group_id@@@
	fi
	

	#create project
        echo @@@create project ${line_arr[1]}@@@
        curl -d "name=${line_arr[1]}&namespace_id=$group_id&public=true&private_token=$PRIVATE_TOKEN" "http://$GITLAB_HOST/api/v3/projects"

	#clone svn to git repo and push to gitlab
	mkdir ${line_arr[2]}
	cd ${line_arr[2]}
	rm -rf ${line_arr[1]}
	cp ../users.txt ./
    	echo @@@git svn clone $repo@@@
    	git svn clone --no-metadata --authors-file=users.txt "${SVN_HOST}/${line_arr[0]}" ${line_arr[1]}
    	cd ${line_arr[1]}
    	echo @@@git remote add@@@
    	git remote add origin git@$GITLAB_HOST:${line_arr[2]}/${line_arr[1]}.git
    	echo @@@git push@@@
    	git push -u origin master
	return=$?
	if [ $return -eq 0 ]; then
		echo ${line_arr[2]},${line_arr[1]},success >> $workdir/svn2gitlab_$time.log
	else
		echo ${line_arr[2]},${line_arr[1]},fail >> $workdir/svn2gitlab_$time.log
	fi
    	#git remote remove origin
    	cd $workdir
done < repolist.txt
